# -*- coding: utf-8 -*-
#Příliš žluťoučký kůň úpěl ďábelské ó - PŘÍLIŠ ŽLUŤOUČKÝ KŮŇ ÚPĚL ĎÁBELSKÉ Ó
#P:/64_PGM/64_PYT/m24b_Argumenty.py
"""
Demonstrační třídy pro výklad o násobném dědění.
"""
from dbg import DBG
if DBG>0: print(f'===== Modul {__name__} ===== START')
############################################################################

from utils import prSE

class BabičkaA:
    count = 0
    def __init__(self, arg_b, **kwds):
        indent = prSE(BabičkaA, 1)
        print(f'{indent}{arg_b=}, {kwds=}')
        BabičkaA.count += 1
        self.ID = BabičkaA.count
        prSE(BabičkaA, 0, f"{self.ID}")
    def __repr__(self):
        return f"{self.__class__.__name__}_{self.ID}"

class MatkaA1(BabičkaA):
    def __init__(self, arg_m1, **kwds):
        indent = prSE(MatkaA1, 1)
        print(f'{indent}{arg_m1=}, {kwds=}')
        super().__init__(**kwds)
        prSE(MatkaA1, 0, f"{self.ID}")

class MatkaA2(BabičkaA):
    def __init__(self, arg_m2, **kwds):
        indent = prSE(MatkaA2, 1)
        print(f'{indent}{arg_m2=}, {kwds=}')
        super().__init__(**kwds)
        prSE(MatkaA2, 0, f"{self.ID}")

class DceraA(MatkaA1, MatkaA2):
    def __init__(self, arg_d, **kwds):
        indent = prSE(DceraA, 1)
        print(f'{indent}{arg_d=}, {kwds=}')
        super().__init__(**kwds)
        prSE(DceraA, 0, f"{self.ID}")


############################################################################
if DBG>0: print(f'===== Modul {__name__} ===== STOP')
