#Příliš žluťoučký kůň úpěl ďábelské ó - PŘÍLIŠ ŽLUŤOUČKÝ KŮŇ ÚPĚL ĎÁBELSKÉ Ó
#P:/64_PGM/64_PYT/m28b_APR.py
"""
Modul demonstruje zpracování argumentů příkazového řádku.
"""
from dbg import DBG
if DBG>0: print(f'===== Modul {__name__} ===== START')
############################################################################

import sys

def main() -> None:
    """Spustí aplikaci podle zadaných argumentů příkazového řádku."""
    args = sys.argv
    if DBG>=0: print(f'Argumenty příkazového řádku:\n  {args}')
    if len(args) <= 1:
        print('Spuštěno bez argumentů -- taky dobrý.')
        return          # ==========>
    prefix = None
    for a in args:
        if DBG>0: print(f'=== Zpracovávám argument {a}, {prefix=}')
        if   prefix==None: prefix = ''
        elif prefix:       print_file(a);       prefix = ''
        elif '-h' == a:    help();    return    # ==========>
        elif '-a' == a:
            print('Ahoj uživatelé!\nJsem rád, že jste mne spustili.\n')
        elif '-p' == a:   prefix = a
        else: raise RuntimeError(f'Neznámý argument: {a}')


def print_file(argument):
    """Vytiskne soubor, jehož název následuje za zadaným prefixem."""
    file = open(argument, 'r', 1, 'utf8')
    print(f'Obsah souboru f{file.name}\n{40*"="}')
    for line in file:  print(line, end='')


def help() -> None:
    """Zobrazí nápovědu k aplikaci."""
    print('Aplikace demonstruje použití argumentů příkazového řádku.\n'
          'Při spuštění můžete zadat následující argumenty:\n'
          '-h  Spustí tuto nápovědu\n'
          '-a  Pozdraví uživatele\n'
          '-p  Očekává název souboru, jehož obsah zobrazí')

if __name__ == '__main__':
    main()


############################################################################
if DBG>0: print(f'===== Modul {__name__} ===== STOP')
