# -*- coding: utf-8 -*-
#Příliš žluťoučký kůň úpěl ďábelské ó - PŘÍLIŠ ŽLUŤOUČKÝ KŮŇ ÚPĚL ĎÁBELSKÉ Ó
#P:/64_PGM/64_PYT/m30c_MetaCls.py
"""
Definice metatřídy MetaCls definované jako třída.
"""

# print('===== START načítání modulu', __name__, '=====')



#Výpis 30.7: Definice metatřídy MetaCls definované jako třída
############################################################################
class MetaCls(type):
    def __prepare__(classname, supers):
        DICT = {'da': 'MF',  'fa': lambda self: f"{self}"}
        print('MetaCls.__prepare__:', f"{classname=}", f"{supers=}",
              f"Vracím slovník {DICT=}", sep='\n...')
        return DICT

    def __new__(meta, classname, supers, classdict):
        CLASS = type.__new__(meta, classname, supers, classdict)
        print('MetaCls.__new__:', f"{meta=}", f"{classname=}",
              f"{supers=}", f"{list(classdict.keys())}",
              f"Vytvořena třída {CLASS}", sep='\n...')
        return CLASS

    def __init__(CLASS, classname, supers, classdict):
        print('MetaCls.__init__:', f"{classname=}",
              f"{supers=}", f"{list(classdict.keys())}",
              f"Inicializována třída {CLASS}", sep='\n...')



############################################################################
# Následuje test funkce metatřídy MetaCls

class Matka30Cls:
    pass

print('===== Vytvářím třídu =====')
class Dcera30Cls(Matka30Cls, metaclass=MetaCls):
    """Metatřída MetaCls je definována jako třída."""
    print('Tělo definované třídy Dcera30Cls spuštěno:')
    data = 'Cls'
    def mtd(self, arg):
        return f"{self.data}({arg})"
    print('Tělo definované třídy Dcera30Cls ukončeno')

print('===== Vytvářím instanci =====')
dc = Dcera30Cls()
print(f"{dc.data=}, {dc.mtd(1)=}, {dc.da=}\n{dc.fa()=}",
      f"\n{type(Dcera30Cls)=}")



# print('===== KONEC načítání modulu', __name__, '=====')
