#Příliš žluťoučký kůň úpěl ďábelské ó - PŘÍLIŠ ŽLUŤOUČKÝ KŮŇ ÚPĚL ĎÁBELSKÉ Ó
#P:/64_PGM/64_PYT/m24c_Komolení.py
"""
Demonstrační třídy pro výklad komolení jmen.
"""
from dbg import DBG
if DBG>0: print(f'===== Modul {__name__} ===== START')
############################################################################

class Bd:
    """Třída reprezentující babičku."""
    __count = 0
    __cpa = 'pr cls Bd'
    cpub  = 'pu cls Bd'
    def __init__(self):
        Bd.__count += 1
        self.ID    = Bd.__count
        self.__ipa ='pr ins Bd'
        self.ipub  ='pu ins Bd'
    def __repr__(self): return f"{self.__class__.__name__}_{self.ID}"
    def __mtd(self):
        return f"Soukr v Bd pro {self}: \n" \
               f"{self.__cpa=}, {self.cpub=}\n{self.__ipa=}, {self.ipub=}"
    def pumtd(self):
        return f"Metoda v Bd pro {self}: \n" \
               f"{self.__cpa=}, {self.cpub=}\n{self.__ipa=}, {self.ipub=}"
    def tmpl(self):
        print(f"{self.__mtd()}\n{self.pumtd()}")


class Md(Bd):
    """Třída reprezentující matku."""
    __cpa = 'pr cls Md'
    cpub  = 'pu cls Md'
    def __init__(self):
        super().__init__()
        self.__ipa ='pr ins Md'
        self.ipub  ='pu ins Md'
    def __mtd(self):
        return f"Soukr v Md pro {self}: \n" \
               f"{self.__cpa=}, {self.cpub=}\n{self.__ipa=}, {self.ipub=}"
    def pumtd(self):
        return f"Metoda v Md pro {self}:\n" \
               f"{self.__cpa=}, {self.cpub=}\n{self.__ipa=}, {self.ipub=}"


############################################################################
if DBG>0: print(f'===== Modul {__name__} ===== STOP')
