# -*- coding: utf-8 -*-
#Příliš žluťoučký kůň úpěl ďábelské ó - PŘÍLIŠ ŽLUŤOUČKÝ KŮŇ ÚPĚL ĎÁBELSKÉ Ó
#P:/64_PGM/64_PYT/m30b_MetaFce.py
"""
Definice metatřídy MetaFce definované jako funkce.
"""

# print('===== START načítání modulu', __name__, '=====')



#Výpis 30.5: Definice metatřídy MetaFce definované jako funkce
############################################################################
def MetaFce(classname, supers, classdict):
    CLASS = type(classname, supers, classdict)
    print('MetaFce:', f"{classname=}", f"{supers=}",
          f"{list(classdict.keys())}",
          f"Vytvořena a inicializována třída {CLASS}", sep='\n...')
    return CLASS

def __prepare__(classname, supers):
    DICT = {'prefix': 'Fce-',  'fa': lambda self: f"{self}"}
    print('MetaFce.__prepare__:', f"{classname=}", f"{supers=}",
          f"Vracím slovník {DICT=}", sep='\n...')
    return DICT
MetaFce.__prepare__ = __prepare__



############################################################################
# Následuje test funkce metatřídy MetaFce

# class Matka30Fce:
#     pass
from m30a_TestMetaXxx import Matka30Xxx as Matka30Fce

print('===== Vytvářím třídu =====')
class Dcera30Fce(Matka30Fce, metaclass=MetaFce):
    """Použitá metatřída MetaFce je definována jako funkce."""
    print('Tělo definované třídy Dcera30Fce spuštěno:')
    data = 'Fce'
    def mtd(self, arg):
        return f"{self.data}({arg})"
    print('Tělo definované třídy Dcera30Fce ukončeno')

print('===== Vytvářím instanci =====')
(df := Dcera30Fce())
print(f"{df.data=}, {df.mtd(1)=}, {df.da=}\n{df.fa()=}"
      f"\n{type(Dcera30Fce)=}")



# print('===== KONEC načítání modulu', __name__, '=====')
